#ifndef TQPLATFORMDEFS_H
#define TQPLATFORMDEFS_H

// Get TQt defines/settings

#include "tqglobal.h"

// Set any POSIX/XOPEN defines at the top of this file to turn on specific APIs

#include <unistd.h>


// We are hot - unistd.h should have turned on the specific APIs we requested


#ifdef TQT_THREAD_SUPPORT
#include <pthread.h>
#endif

#include <dirent.h>
#include <fcntl.h>
#include <grp.h>
#include <pwd.h>
#include <signal.h>
#include <dlfcn.h>

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/ipc.h>
#include <sys/time.h>
#include <sys/shm.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/wait.h>

// DNS header files are not fully covered by X/Open specifications.
// In particular nothing is said about res_* :/
// On IRIX header files <netinet/in.h> and <arpa/nameser.h> are not
// included by <resolv.h>. Note that <arpa/nameser.h> must be included
// before <resolv.h>.
#include <netinet/in.h>
#include <arpa/nameser.h>
#include <resolv.h>


#if !defined(TQT_NO_COMPAT)
#define TQT_STATBUF		struct stat
#define TQT_STATBUF4TSTAT	struct stat
#define TQT_STAT			::stat
#define TQT_FSTAT		::fstat
#define TQT_STAT_REG		S_IFREG
#define TQT_STAT_DIR		S_IFDIR
#define TQT_STAT_MASK		S_IFMT
#define TQT_STAT_LNK		S_IFLNK
#define TQT_FILENO		fileno
#define TQT_OPEN			::open
#define TQT_CLOSE		::close
#define TQT_LSEEK		::lseek
#define TQT_READ			::read
#define TQT_WRITE		::write
#define TQT_ACCESS		::access
#define TQT_GETCWD		::getcwd
#define TQT_CHDIR		::chdir
#define TQT_MKDIR		::mkdir
#define TQT_RMDIR		::rmdir
#define TQT_OPEN_RDONLY		O_RDONLY
#define TQT_OPEN_WRONLY		O_WRONLY
#define TQT_OPEN_RDWR		O_RDWR
#define TQT_OPEN_CREAT		O_CREAT
#define TQT_OPEN_TRUNC		O_TRUNC
#define TQT_OPEN_APPEND		O_APPEND
#endif

#define TQT_SIGNAL_RETTYPE	void
#if defined(_LANGUAGE_C_PLUS_PLUS) || !defined(_SGIAPI)
#define TQT_SIGNAL_ARGS		int
#else
#define TQT_SIGNAL_ARGS		void
#endif
#define TQT_SIGNAL_IGNORE	SIG_IGN

#if defined(_XOPEN_SOURCE) && (_XOPEN_SOURCE-0 >= 500)
#define TQT_SOCKLEN_T		size_t
#else
#define TQT_SOCKLEN_T		int
#endif

#if 0
// on Irix 6.5 and better only - but how to check for it?
#if defined(_SGIAPI)
#define TQT_SNPRINTF		::snprintf
#define TQT_VSNPRINTF		::vsnprintf
#endif
#endif

#endif // TQPLATFORMDEFS_H

