#ifndef TQPLATFORMDEFS_H
#define TQPLATFORMDEFS_H

// Get TQt defines/settings

#include "tqglobal.h"

// Set any POSIX/XOPEN defines at the top of this file to turn on specific APIs

#include <unistd.h>


// We are hot - unistd.h should have turned on the specific APIs we requested


#ifdef TQT_THREAD_SUPPORT
#include <pthread.h>
#endif

#include <dirent.h>
#include <fcntl.h>
#include <grp.h>
#include <pwd.h>
#include <signal.h>
#include <dlfcn.h>

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/filio.h>
#include <sys/ipc.h>
#include <sys/time.h>
#include <sys/shm.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/wait.h>

// DNS header files are not fully covered by X/Open specifications.
// In particular nothing is said about res_* :/
#include <resolv.h>


#if !defined(TQT_NO_COMPAT)
#define TQT_STATBUF		struct stat
#define TQT_STATBUF4TSTAT	struct stat
#define TQT_STAT			::stat
#define TQT_FSTAT		::fstat
#define TQT_STAT_REG		S_IFREG
#define TQT_STAT_DIR		S_IFDIR
#define TQT_STAT_MASK		S_IFMT
#define TQT_STAT_LNK		S_IFLNK
#define TQT_FILENO		fileno
#define TQT_OPEN			::open
#define TQT_CLOSE		::close
#define TQT_LSEEK		::lseek
#define TQT_READ			::read
#define TQT_WRITE		::write
#define TQT_ACCESS		::access
#define TQT_GETCWD		::getcwd
#define TQT_CHDIR		::chdir
#define TQT_MKDIR		::mkdir
#define TQT_RMDIR		::rmdir
#define TQT_OPEN_RDONLY		O_RDONLY
#define TQT_OPEN_WRONLY		O_WRONLY
#define TQT_OPEN_RDWR		O_RDWR
#define TQT_OPEN_CREAT		O_CREAT
#define TQT_OPEN_TRUNC		O_TRUNC
#define TQT_OPEN_APPEND		O_APPEND
#endif

#define TQT_SIGNAL_RETTYPE	void
#define TQT_SIGNAL_ARGS		int
#define TQT_SIGNAL_IGNORE	SIG_IGN

// on Reliant 5.45 and if __LP64__ is *not* defined:
// - socket functions use 'size_t'
// - if _SOCKLEN_T is defined 'socklen_t' is typedef'ed to 'size_t'
// note that 'size_t' would always be a good choice in this context
#if defined(_SOCKLEN_T)
#  define TQT_SOCKLEN_T		socklen_t
#else
#  define TQT_SOCKLEN_T		size_t
#endif

#if !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE) || (_XOPEN_SOURCE-0 >= 500)
#define TQT_SNPRINTF		::snprintf
#define TQT_VSNPRINTF		::vsnprintf
#endif


#endif // TQPLATFORMDEFS_H
