/****************************************************************************
**
** Global type declarations and definitions
**
** Copyright (C) 2010 Timothy Pearson and (C) 1992-2008 Trolltech ASA.
**
** This file is part of the tools module of the TQt GUI Toolkit.
**
** This file may be used under the terms of the GNU General
** Public License versions 2.0 or 3.0 as published by the Free
** Software Foundation and appearing in the files LICENSE.GPL2
** and LICENSE.GPL3 included in the packaging of this file.
** Alternatively you may (at your option) use any later version
** of the GNU General Public License if such license has been
** publicly approved by Trolltech ASA (or its successors, if any)
** and the KDE Free TQt Foundation.
**
** Please review the following information to ensure GNU General
** Public Licensing requirements will be met:
** http://trolltech.com/products/qt/licenses/licensing/opensource/.
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://trolltech.com/products/qt/licenses/licensing/licensingoverview
** or contact the sales department at sales@trolltech.com.
**
** This file may be used under the terms of the Q Public License as
** defined by Trolltech ASA and appearing in the file LICENSE.TQPL
** included in the packaging of this file.  Licensees holding valid TQt
** Commercial licenses may use this file in accordance with the TQt
** Commercial License Agreement provided with the Software.
**
** This file is provided "AS IS" with NO WARRANTY OF ANY KIND,
** INCLUDING THE WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE. Trolltech reserves all rights not granted
** herein.
**
**********************************************************************/

#if defined(TQ_TEMPLATEDLL) && ( !defined(TQ_CC_BOR) || !defined(TQT_MAKEDLL) || defined(TQ_EXPORT_TEMPLATES) )
// TQMOC_SKIP_BEGIN

#if defined(TQ_DEFINED_TQASCIIDICT) && defined(TQ_DEFINED_TQCONNECTION_LIST) && !defined(TQ_EXPORTED_TQASCIIDICT_TEMPLATES)
#define TQ_EXPORTED_TQASCIIDICT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQAsciiDictIterator<TQConnectionList>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQAsciiDict<TQConnectionList>;
#endif

#if defined(TQ_DEFINED_TQSTYLESHEET) && defined(TQ_DEFINED_TQDICT) && !defined(TQ_EXPORTED_TQSTYLESHEET_TEMPLATES)
#define TQ_EXPORTED_TQSTYLESHEET_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQDict<TQStyleSheetItem>;
#endif

#if defined(TQ_DEFINED_TQLIBRARY) && defined(TQ_DEFINED_TQDICT) && !defined(TQ_EXPORTED_TQDICTLIBRARY_TEMPLATES)
#define TQ_EXPORTED_TQDICTLIBRARY_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQDict<TQLibrary>; // for TQtopia
#endif

#if defined(TQ_DEFINED_TQGUARDEDPTR) && defined(TQ_DEFINED_TQOBJECT) && !defined(TQ_EXPORTED_TQGUARDEDPTROBJECT_TEMPLATES)
#define TQ_EXPORTED_TQGUARDEDPTROBJECT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQGuardedPtr<TQObject>;
#endif

// needed for TQtopia
#if defined(TQ_DEFINED_TQGUARDEDPTR) && defined(TQ_DEFINED_TQWIDGET) && !defined(TQ_EXPORTED_TQGUARDEDPTRTQWIDGET_TEMPLATES)
#define TQ_EXPORTED_TQGUARDEDPTRTQWIDGET_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQGuardedPtr<TQWidget>;
#endif

#if defined(TQ_DEFINED_TQGUARDEDPTR) && defined(TQ_DEFINED_TQACCESSIBLE_OBJECT) && !defined(TQ_EXPORTED_TQACCESSIBLEOBJECT_TEMPLATES)
#define TQ_EXPORTED_TQACCESSIBLEOBJECT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQGuardedPtr<TQAccessibleObject>;
#endif

#if defined(TQ_DEFINED_TQINTDICT) && !defined(TQ_EXPORTED_TQINTDICT_TEMPLATES)
#define TQ_EXPORTED_TQINTDICT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQIntDict<int>;
#endif

#if defined(TQ_DEFINED_TQINTDICT) && defined(TQ_DEFINED_TQWIDGET) && !defined(TQ_EXPORTED__TEMPLATES)
#define TQ_EXPORTED__TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQIntDictIterator<TQWidget>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQIntDict<TQWidget>;
#endif

#if defined(TQ_DEFINED_TQMAP) && !defined(TQ_EXPORTED_TQMAPBASIC_TEMPLATES)
#define TQ_EXPORTED_TQMAPBASIC_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMap<int, int>; // for TQtopia
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMap<int, bool>; // for TQtopia
#endif

#if defined(TQ_DEFINED_TQMAP) && defined(TQ_DEFINED_TQSTRING) && !defined(TQ_EXPORTED_TQMAPTQSTRING_TEMPLATES)
#define TQ_EXPORTED_TQMAPTQSTRING_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMap<TQString, TQString>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMap<TQString, int>; // for TQtopia
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMap<int, TQString>; // for TQtopia
#endif

#if defined(TQ_DEFINED_TQMEMARRAY)  && !defined(TQ_EXPORTED_TQMEMARRAY_BASIC_TEMPLATES)
#define TQ_EXPORTED_TQMEMARRAY_BASIC_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMemArray<int>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMemArray<bool>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMemArray<char>;
#endif

#if defined(TQ_DEFINED_TQMEMARRAY) && defined(TQ_DEFINED_TQPOINT)  && !defined(TQ_EXPORTED_TQMEMARAYPOINT_TEMPLATES)
#define TQ_EXPORTED_TQMEMARAYPOINT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQMemArray<TQPoint>;
#endif

#if defined(TQ_DEFINED_TQPTRLIST)  && !defined(TQ_EXPORTED_TQPTRLIST_BASIC_TEMPLATES)
#define TQ_EXPORTED_TQPTRLIST_BASIC_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrListIterator<char>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrList<char>;
#endif

#if defined(TQ_DEFINED_TQPTRLIST) && defined(TQ_DEFINED_TQWIDGET)  && !defined(TQ_EXPORTED_TQPTRLISTWIDGET_TEMPLATES)
#define TQ_EXPORTED_TQPTRLISTWIDGET_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrListIterator<TQWidget>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrList<TQWidget>;
#endif

#if defined(TQ_DEFINED_TQPTRLIST) && defined(TQ_DEFINED_TQCONNECTION)  && !defined(TQ_EXPORTED_TQPTRLISTCONNECTION_TEMPLATES)
#define TQ_EXPORTED_TQPTRLISTCONNECTION_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrListIterator<TQConnection>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrList<TQConnection>;
#endif

#if defined(TQ_DEFINED_TQPTRLIST) && defined(TQ_DEFINED_TQOBJECT)  && !defined(TQ_EXPORTED_TQPTRLISTOBJECT_TEMPLATES)
#define TQ_EXPORTED_TQPTRLISTOBJECT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrListIterator<TQObject>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrList<TQObject>;
#endif

#if defined(TQ_DEFINED_TQPTRLIST) && defined(TQ_DEFINED_TQDOCKWINDOW)  && !defined(TQ_EXPORTED_TQPTRLISTDOCWINDOW_TEMPLATES)
#define TQ_EXPORTED_TQPTRLISTDOCWINDOW_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrListIterator<TQDockWindow>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrList<TQDockWindow>;
#endif

#if defined(TQ_DEFINED_TQPTRVECTOR)  && !defined(TQ_EXPORTED_TQPTRVECTOR_BASIC_TEMPLATES)
#define TQ_EXPORTED_TQPTRVECTOR_BASIC_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrVector<int>;
#endif

#if defined(TQ_DEFINED_TQPTRVECTOR) && defined(TQ_DEFINED_TQSTYLESHEET)  && !defined(TQ_EXPORTED_TQPTRVECTORSTYLESHEETITEM_TEMPLATES)
#define TQ_EXPORTED_TQPTRVECTORSTYLESHEETITEM_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrVector<TQStyleSheetItem>;
#endif

#if defined(TQ_DEFINED_TQPTRVECTOR) && defined(TQ_DEFINED_TQWIDGET)  && !defined(TQ_EXPORTED_TQPTRVECTORWIDGET_TEMPLATES)
#define TQ_EXPORTED_TQPTRVECTORWIDGET_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrVector<TQWidget>;
#endif

#if defined(TQ_DEFINED_TQPTRVECTOR) && defined(TQ_DEFINED_TQCONNECTION_LIST)  && !defined(TQ_EXPORTED_TQPTRVECTORCONNECTTIONLIST_TEMPLATES)
#define TQ_EXPORTED_TQPTRVECTORCONNECTTIONLIST_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrVector<TQConnectionList>;
#endif

#if defined(TQ_DEFINED_TQVALUELIST)  && !defined(TQ_EXPORTED_TQVALUELIST_BASIC_TEMPLATES)
#define TQ_EXPORTED_TQVALUELIST_BASIC_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueListIterator<bool>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueList<bool>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueListIterator<int>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueList<int>;
#endif

#if defined(TQ_DEFINED_TQVALUELIST) && defined(TQ_DEFINED_TQRECT)  && !defined(TQ_EXPORTED_TQVALUELISTRECT_TEMPLATES)
#define TQ_EXPORTED_TQVALUELISTRECT_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueListIterator<TQRect>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueList<TQRect>;
#endif

#if defined(TQ_DEFINED_TQVALUELIST) && defined(TQ_DEFINED_TQSTRING)  && !defined(TQ_EXPORTED_TQVALUELISTSTRING_TEMPLATES)
#define TQ_EXPORTED_TQVALUELISTSTRING_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueListIterator<TQString>;
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueList<TQString>;
#endif

// TQStylesheet template exports
#if defined(TQ_DEFINED_TQVALUELIST) && defined(TQ_DEFINED_TQPTRVECTOR) && defined(TQ_DEFINED_TQSTYLESHEET)  && !defined(TQ_EXPORTED_TQSTYLESHEETITEM1_TEMPLATES)
#define TQ_EXPORTED_TQSTYLESHEETITEM1_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueList< TQPtrVector< TQStyleSheetItem> >;
#endif

#if defined(TQ_DEFINED_TQVALUELIST) && defined(TQ_DEFINED_TQSTYLESHEET)  && !defined(TQ_EXPORTED_TQSTYLESHEETITEM2_TEMPLATES)
#define TQ_EXPORTED_TQSTYLESHEETITEM2_TEMPLATES
TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQValueList<TQStyleSheetItem::ListStyle>;
#endif

// qcanvas template exports
#if defined(TQ_DEFINED_TQPTRLIST)  && defined(TQ_DEFINED_TQCANVAS) && !defined(TQ_EXPORTED_TQCANVAS1_TEMPLATES)
#define TQ_EXPORTED_TQCANVAS1_TEMPLATES
TQM_TEMPLATE_EXTERN_CANVAS template class TQM_EXPORT_CANVAS TQPtrListIterator< TQCanvasItem >;
TQM_TEMPLATE_EXTERN_CANVAS template class TQM_EXPORT_CANVAS TQPtrList< TQCanvasItem >;
TQM_TEMPLATE_EXTERN_CANVAS template class TQM_EXPORT_CANVAS TQPtrListIterator< TQCanvasView >;
TQM_TEMPLATE_EXTERN_CANVAS template class TQM_EXPORT_CANVAS TQPtrList< TQCanvasView >;
#endif

// qtable template exports
#if defined(TQ_DEFINED_TQPTRLIST) && defined(TQ_DEFINED_TQTABLE_SELECTION) && !defined(TQ_EXPORTED_TQTABLESELECTION_TEMPLATES)
#define TQ_EXPORTED_TQTABLESELECTION_TEMPLATES
TQM_TEMPLATE_EXTERN_TABLE template class TQM_EXPORT_TABLE TQPtrList<TQTableSelection>;
#endif

#if defined(TQ_DEFINED_TQTABLE_ITEM) && defined(TQ_DEFINED_TQPTRVECTOR) && !defined(TQ_EXPORTED_TQTABLEITEM_TEMPLATES)
#define TQ_EXPORTED_TQTABLEITEM_TEMPLATES
TQM_TEMPLATE_EXTERN_TABLE template class TQM_EXPORT_TABLE TQPtrVector<TQTableItem>;
#endif

#if defined(TQ_DEFINED_TQTABLE) && defined(TQ_DEFINED_TQPTRVECTOR)
//TQ_TEMPLATE_EXTERN template class TQ_EXPORT TQPtrVector<TQTable>;
#endif

// qsqlextension template exports
#if defined(TQ_DEFINED_TQSQLEXTENSION) && defined(TQ_DEFINED_TQMAP) && defined(TQ_DEFINED_TQVALUEVECTOR) && defined(TQ_DEFINED_TQSTRING) && !defined(TQ_EXPORTED_TQSQLEXTENSION_TEMPLATES)
#define TQ_EXPORTED_TQSQLEXTENSION_TEMPLATES
TQM_TEMPLATE_EXTERN_SQL template class TQM_EXPORT_SQL TQMap<TQString,Param>;
TQM_TEMPLATE_EXTERN_SQL template class TQM_EXPORT_SQL TQValueVector<Holder>;
#endif


// TQMOC_SKIP_END
#endif // template defined
